#!/bin/bash
## © University of Southampton IT Innovation Centre, 2018
##
## Copyright in this software belongs to University of Southampton
## IT Innovation Centre of Gamma House, Enterprise Road, 
## Chilworth Science Park, Southampton, SO16 7NS, UK.
##
## This software may not be used, sold, licensed, transferred, copied
## or reproduced in whole or in part in any manner or form or in or
## on any media by any person other than in accordance with the terms
## of the Licence Agreement supplied with the software, or otherwise
## without the prior written consent of the copyright owners.
##
## This software is distributed WITHOUT ANY WARRANTY, without even the
## implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
## PURPOSE, except where stated in the Licence Agreement supplied with
## the software.
##
##      Created By :            Stephen Phillips
##      Created Date :          19-02-2018
##      Created for Project :   FLAME

# This script reads stdin and expects the output of cvlc.
# It is used by the run.sh script and receives the output of the cvlc client.
# It counts the number of times the frame "dropping" error is seen and every 10 times it sends a message to telegraf reporting "another 10" errors.

if [ "$#" -ne 1 ]; then
    echo "Error: illegal number of arguments: "$#
    echo "Usage: report.sh <client number>"
    exit 
fi

COUNTER=$1
TELEGRAF=http://localhost:8186

ERR_COUNT=0
while read line; do
  if [[ $line = *"dropping"* ]]; then
    ERR_COUNT=$(($ERR_COUNT + 1))
  fi
  TEN=$((ERR_COUNT % 10))
  if [ $TEN -eq 0 ]; then
    curl -i -XPOST "${TELEGRAF}/write?precision=s" --data-binary "vlc,client=${COUNTER} drop_error=10 $(date +%s)" >& /dev/null
  fi
done